"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _effects = require("redux-saga/effects");

var _get_hash = _interopRequireDefault(require("./get_hash"));

var _constants = require("./constants");

var _action_types = require("./action_types");

var _unsubscribe_view_model_topics_saga = _interopRequireDefault(require("./unsubscribe_view_model_topics_saga"));

var eventListenerSaga =
/*#__PURE__*/
_regenerator.default.mark(function eventListenerSaga(_ref, connectAction) {
  var viewModels, sagaKey, sagaManager, eventTypes, store, _ref2, event, _ref3, viewModelLastTimestampMap, key, lastTimestamp;

  return _regenerator.default.wrap(function eventListenerSaga$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          viewModels = _ref.viewModels, sagaKey = _ref.sagaKey, sagaManager = _ref.sagaManager, eventTypes = _ref.eventTypes, store = _ref.store;

        case 1:
          if (!true) {
            _context.next = 26;
            break;
          }

          _context.next = 4;
          return (0, _effects.take)(function (action) {
            return action.type === _action_types.DISPATCH_TOPIC_MESSAGE && eventTypes.indexOf(action.message.type) > -1 && (connectAction.aggregateIds === '*' || connectAction.aggregateIds.indexOf(action.message.aggregateId) > -1);
          });

        case 4:
          _ref2 = _context.sent;
          event = _ref2.message;
          _context.next = 8;
          return (0, _effects.select)();

        case 8:
          _ref3 = _context.sent;
          viewModelLastTimestampMap = _ref3.viewModels[_constants.lastTimestampMap];
          key = "" + connectAction.viewModelName + (0, _get_hash.default)(connectAction.aggregateIds) + (0, _get_hash.default)(connectAction.aggregateArgs);
          lastTimestamp = viewModelLastTimestampMap[key];

          if (!(event.timestamp >= lastTimestamp)) {
            _context.next = 24;
            break;
          }

          _context.prev = 13;
          _context.next = 16;
          return (0, _effects.put)(event);

        case 16:
          viewModelLastTimestampMap[key] = event.timestamp;
          _context.next = 24;
          break;

        case 19:
          _context.prev = 19;
          _context.t0 = _context["catch"](13);
          // eslint-disable-next-line no-console
          console.warn(_context.t0);
          return _context.delegateYield((0, _unsubscribe_view_model_topics_saga.default)({
            viewModels: viewModels,
            viewModelName: connectAction.viewModelName,
            aggregateIds: connectAction.aggregateIds
          }), "t1", 23);

        case 23:
          return _context.delegateYield(sagaManager.stop("" + _action_types.CONNECT_VIEWMODEL + sagaKey, function () {
            return store.dispatch((0, _objectSpread2.default)({}, connectAction, {
              skipConnectionManager: true
            }));
          }), "t2", 24);

        case 24:
          _context.next = 1;
          break;

        case 26:
        case "end":
          return _context.stop();
      }
    }
  }, eventListenerSaga, this, [[13, 19]]);
});

var _default = eventListenerSaga;
exports.default = _default;
//# sourceMappingURL=event_listener_saga.js.map